import { useEffect, useMemo } from 'react';
import SuperclusterClass from './Supercluster';
export function useClusterer(data, mapDimensions, region, options) {
  const supercluster = useMemo(() => new SuperclusterClass(options).load(data), [data, options === null || options === void 0 ? void 0 : options.extent, options === null || options === void 0 ? void 0 : options.maxZoom, options === null || options === void 0 ? void 0 : options.minZoom, options === null || options === void 0 ? void 0 : options.minPoints, options === null || options === void 0 ? void 0 : options.radius]);
  const points = useMemo(() => supercluster.getClustersFromRegion(region, mapDimensions).map(c => {
    var _c$properties;

    const cid = c === null || c === void 0 ? void 0 : (_c$properties = c.properties) === null || _c$properties === void 0 ? void 0 : _c$properties.cluster_id;
    if (!cid) return c;
    return { ...c,
      properties: { ...c.properties,
        getClusterExpansionRegion: () => supercluster.expandCluster(cid)
      }
    };
  }), [supercluster, region.latitude, region.longitude, region.latitudeDelta, region.longitudeDelta, mapDimensions.width, mapDimensions.height]);
  useEffect(() => () => supercluster.destroy(), [supercluster]); // @ts-ignore FIXME: Type

  return [points, supercluster];
}
//# sourceMappingURL=useClusterer.js.map